USE [PAS] 
GO 


/****** Object: View [dbo].[View_Patnt_Perca] Script Date: 02/29/2012 09:53:31 ******/ 

create VIEW [dbo].[View_Patnt_Perca] 
AS 
SELECT ppc.PATNT_REFNO, ISNULL(pc.FORENAME, '') + ' ' + ISNULL(pc.SURNAME, '') AS emergencycontactname, 
reltn.DESCRIPTION AS emergencycontactrelationship, ISNULL(PHONE.line1, MOBIL.line1) AS emergencycontactphone, ppc.MODIF_DTTM,ppc.perca_refno
FROM PIMSP..PATIENT_PERSONAL_CARERS AS ppc LEFT OUTER JOIN 
dbo.View_PERCA_addresses AS PHONE ON ppc.PERCA_REFNO = PHONE.perca_refno AND PHONE.adtyp_code = 'PHONE' LEFT OUTER JOIN
dbo.View_PERCA_addresses AS MOBIL ON ppc.PERCA_REFNO = MOBIL.perca_refno AND MOBIL.adtyp_code = 'MOB' INNER JOIN
PIMSP..REFERENCE_VALUES AS petyp ON ppc.PETYP_REFNO = petyp.RFVAL_REFNO INNER JOIN 
PIMSP..PERSONAL_CARERS AS pc ON ppc.PERCA_REFNO = pc.PERCA_REFNO INNER JOIN 
PIMSP..REFERENCE_VALUES AS reltn ON ppc.RELTN_REFNO = reltn.RFVAL_REFNO 
WHERE (ppc.END_DTTM IS NULL OR 
ppc.END_DTTM >= GETDATE()) AND (ppc.CURNT_FLAG = 'Y') AND (ISNULL(ppc.ARCHV_FLAG, 'N') = 'N') AND (petyp.MAIN_CODE = 'EMERG' OR
petyp.MAIN_CODE = 'NOK') 
GO 









/****** Object: View [dbo].[View_PERCA_addresses] Script Date: 02/29/2012 09:53:31 ******/ 



CREATE view [dbo].[View_PERCA_addresses] 
as select 
r.perca_refno, 
a.adtyp_code, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.line1 ELSE a.line1 END AS LINE1, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.LINE2 ELSE a.LINE2 END AS LINE2, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.LINE3 ELSE a.LINE3 END AS LINE3, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.LINE4 ELSE a.LINE4 END AS LINE4, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.suburb ELSE a.suburb END AS Suburb, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.pcode ELSE a.pcode END AS PCODE, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.STATE_CODE ELSE a.STATE_CODE END AS STATE_CODE,
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN cntry.DESCRIPTION ELSE cntry.DESCRIPTION END AS cntry
from 
Pimsp..address_roles r, 
Pimsp..addresses a 
left outer join 
Pimsp..reference_values cntry 
on 
cntry.rfval_refno = a.cntry_refno 
where 
r.perca_refno is not null 
and r.rotyp_code = 'HOME' 
and r.end_dttm is null 
and isnull(r.archv_flag,'N') = 'N' 
and r.addss_refno = a.addss_refno 
and a.end_dttm is null 
and isnull(a.archv_flag,'N') = 'N' 



/****** Object: View [dbo].[View_patientDemographics] Script Date: 02/29/2012 09:53:31 ******/ 



CREATE view [dbo].[View_patientDemographics] 
as 
SELECT distinct p.PASID AS patientID, p.SURNAME AS familyName, 
ISNULL(p.SECOND_FORENAME, '') + ' ' + ISNULL(p.THIRD_FORENAME, '') + ' ' + ISNULL(p.FOURTH_FORENAME, '') AS
middleInitialOrName, p.FORENAME AS givenName, p.DTTM_OF_BIRTH AS dateTimeOfBirth, 
CASE p.sexxx_refno WHEN 1978 THEN 'M' WHEN 1976 THEN 'F' ELSE 'U' END AS dd, 
phone.line1 AS phone, postl.line1 AS streetaddress1, 
postl.line2 AS streetaddress2, postl.suburb AS city, 
postl.state_code AS stateorprovince, postl.pcode AS ziporpostalcode, 
postl.cntry AS country, PPC.pcpclinicianid as pcpclinicianid, 
PPC.pcpclinicianidtype as pcpclinicianidtype, PPC.pcpclinicid pcpclinicid, 
Perca.emergencycontactname as emergencycontactname, Perca.emergencycontactrelationship as emergencycontactrelationship,
Perca.emergencycontactphone as emergencycontactphone 
FROM PIMSP..PATIENTS AS p LEFT OUTER JOIN 
dbo.View_PATNT_addresses AS postl ON p.PATNT_REFNO = postl.patnt_refno and postl.roles_refno in (select top 1 roles_refno from dbo.View_PATNT_addresses where patnt_refno=postl.patnt_refno AND adtyp_code = 'POSTL' order by start_dttm desc) LEFT OUTER JOIN
dbo.View_PATNT_addresses AS phone ON p.PATNT_REFNO = phone.patnt_refno and phone.roles_refno in (select top 1 roles_refno from dbo.View_PATNT_addresses where patnt_refno=phone.patnt_refno AND adtyp_code = 'PHONE' order by start_dttm desc) LEFT OUTER JOIN
dbo.View_Patnt_PC AS PPC ON p.PATNT_REFNO = PPC.PATNT_REFNO and ppc.pcpclinicianidtype='GMPRC' LEFT OUTER JOIN
dbo.View_Patnt_Perca AS Perca ON p.PATNT_REFNO = Perca.PATNT_REFNO and perca.perca_refno in (select top 1 perca_refno from dbo.View_Patnt_Perca where patnt_refno=perca.patnt_refno order by modif_dttm desc)
WHERE (ISNULL(p.ARCHV_FLAG, 'N') = 'N') and (p.MERGE_MINOR_FLAG = 'N') 
GO 


/****** Object: View [dbo].[View_PATNT_addresses] Script Date: 02/29/2012 09:53:31 ******/ 


CREATE VIEW [dbo].[View_PATNT_addresses] 
AS 
SELECT r.PATNT_REFNO, a.ADTYP_CODE, CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.line1 ELSE a.line1 END AS LINE1,
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.LINE2 ELSE a.LINE2 END AS LINE2, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.LINE3 ELSE a.LINE3 END AS LINE3, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.LINE4 ELSE a.LINE4 END AS LINE4, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.suburb ELSE a.suburb END AS Suburb, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.pcode ELSE a.pcode END AS PCODE, 
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN a.STATE_CODE ELSE a.STATE_CODE END AS STATE_CODE,
CASE r.secure_flag WHEN 'Y' THEN '**Secure Address**' WHEN 'N' THEN cntry.DESCRIPTION ELSE cntry.DESCRIPTION END AS cntry,
r.ROLES_REFNO, r.START_DTTM 
FROM PIMSP..ADDRESS_ROLES AS r INNER JOIN 
PIMSP..ADDRESSES AS a LEFT OUTER JOIN 
PIMSP..REFERENCE_VALUES AS cntry ON cntry.RFVAL_REFNO = a.CNTRY_REFNO ON r.ADDSS_REFNO = a.ADDSS_REFNO
WHERE (r.PATNT_REFNO is not null) AND (r.ROTYP_CODE = 'HOME') AND (r.END_DTTM IS NULL) AND (ISNULL(r.ARCHV_FLAG, 'N') = 'N') AND
(a.END_DTTM IS NULL) AND (ISNULL(a.ARCHV_FLAG, 'N') = 'N') 
GO 
